// shades on a per-fragment basis according to the
// standard diffuse lighting model

varying vec4 myColor;

void main()
{
	gl_Position = ftransform();
	
	vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
	vec4 vertex = gl_ModelViewMatrix * gl_Vertex;
	vec3 light = normalize(gl_LightSource[0].diffuse.rgb - vertex.xyz);
	
	vec4 ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	vec4 globalAmbient = gl_LightModel.ambient * gl_FrontMaterial.ambient;
	
	float NdotL = dot(normal, light);
	myColor = ambient + globalAmbient + gl_FrontMaterial.diffuse * gl_Color * vec4(max(0.0, NdotL));
}