varying vec3 hatchWeight1;	// weight for hatch tecture unit 0, 1, 2
varying vec3 hatchWeight2;  // weight for hatch texture unit 3, 4, 5
varying vec2 texCoord;

void main()
{
    texCoord = vec2(gl_MultiTexCoord0);
	gl_Position = ftransform();
	
	vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
	vec4 vertex = gl_ModelViewMatrix * gl_Vertex;
	vec3 light = normalize(gl_LightSource[0].diffuse.rgb - vertex.xyz);
	
	float diffuseValue = max(dot(normal, light), 0.0);
	
	float hatchLevel = diffuseValue * 6.0;
	
	if (hatchLevel >= 5.0)
	{
		hatchWeight1.x = 1.0;
	}
	else if (hatchLevel >= 4.0)
	{
		hatchWeight1.x = 1.0 - (5.0 - hatchLevel);
		hatchWeight1.y = 1.0 - hatchWeight1.x;
	}
	else if (hatchLevel >= 3.0)
	{
		hatchWeight1.y = 1.0 - (4.0 - hatchLevel);
		hatchWeight1.z = 1.0 - hatchWeight1.y;
	}
	else if (hatchLevel >= 2.0)
	{
		hatchWeight1.z = 1.0 - (3.0 - hatchLevel);
		hatchWeight2.x = 1.0 - hatchWeight1.z;
	}
	else if (hatchLevel >= 1.0)
	{
		hatchWeight2.x = 1.0 - (2.0 - hatchLevel);
		hatchWeight2.y = 1.0 - hatchWeight2.x;
	}
	else
	{
		hatchWeight2.y = 1.0 - (1.0 - hatchLevel);
		hatchWeight2.z = 1.0 - hatchWeight1.y;
	}	
}