varying vec4 myColor;
uniform float blueShift;
uniform float blueLuminance;
uniform float yellowShift;
uniform float yellowLuminance;

void main()
{
	gl_Position = ftransform();
	
	vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
	vec4 vertex = gl_ModelViewMatrix * gl_Vertex;
	vec3 light = normalize(gl_LightSource[0].position.xyz - vertex.xyz);
	vec3 halfVec = normalize(light + vec3(0.0, 0.0, 1.0));
	const float spec = 128.0;
	
	float NdotL = dot(normal, light);
	float NdotH = dot(normal, halfVec);
	
	vec4 specular = vec4(pow(max(0.0, NdotH), spec));
	
	vec4 kBlue = vec4(0.0, 0.0, clamp(blueShift, 0.0, 1.0), 1.0);
	vec4 kCool = kBlue + blueLuminance * gl_FrontMaterial.diffuse;
	
	vec4 kYellow = vec4(clamp(yellowShift, 0.0, 1.0), clamp(yellowShift, 0.0, 1.0), 0.0, 1.0);
	vec4 kWarm = kYellow + yellowLuminance * gl_FrontMaterial.diffuse;
	
	myColor = (((1.0 + NdotL) / 2.0) * kWarm + (1.0 - ((1.0 + NdotL) / 2.0)) * kCool) + specular;
}